#ifndef VERNAM_H
#define VERNAM_H

class Vernam {
	#define VERSION       "0.1.0"
	#define MAGIC_NUMBER  "OTP\x1B"
	#define MAGIC_NUM_LEN 4
	#define SALT_LEN      8
	#define BUF_LEN       4096

	#define EncryptionMode char
	#define UNDEFINED  0
	#define HELP       1
	#define ENCRYPT    2
	#define DECRYPT    3

	private:
		char* _arg0;
		std::ostream* _cout;
		std::istream* _cin;
		EncryptionMode _mode;
		std::string _password;
		const char* _cinFile;
		const char* _coutFile;
	
		void encrypt();
		void decrypt();
		void doEncrypt(char* salt);
		void showHelp(bool showDetails);
		void splitSingleArgs(int argc, char* argv[], int* processedArgs);
		void initRun();
	public:
		int _exitCode;
	
		Vernam(int argc, char* argv[]);
		void run();
};

#endif